import { Input, Component, OnInit, Inject, Host } from 'ng-metadata/core';
import { CorTableComponent } from './cor-table.component';


/**
 * Defines a column (optionally sortable) in the table.
 */
@Component({
  selector: 'cor-table-col',
  template: '',
})
export class CorTableColumn implements OnInit {
  @Input('@') public title: string;
  @Input('@') public templateurl: string;
  @Input('@') public datafield: string;
  @Input('@') public sortfield: string;
  @Input('@') public selected: string;
  @Input('@') public dataKind: string;

  constructor(@Host() @Inject(CorTableComponent) private parent: CorTableComponent) {

  }

  public ngOnInit(): void {
    this.parent.addColumn(this);
  }

  public isNumeric(): boolean {
    return this.dataKind == 'datetime';
  }

  public processColumnForOrdered(tableService: any, value: any): any {
    if (this.dataKind == 'datetime') {
       return tableService.getReversedTimestamp(value);
    }

    return value;
  }
}
