/**
 * An element which displays a link to a repository image.
 */
angular.module('quay').directive('imageLink', function () {
  var directiveDefinitionObject = {
    priority: 0,
    templateUrl: '/static/directives/image-link.html',
    replace: false,
    transclude: true,
    restrict: 'C',
    scope: {
      'repository': '=repository',
      'imageId': '=imageId',
      'manifestDigest': '=?manifestDigest'
    },
    controller: function($scope, $element) {
      $scope.hasSHA256 = function(digest) {
        return digest && digest.indexOf('sha256:') == 0;
      };

      $scope.getShortDigest = function(digest) {
        return digest.substr('sha256:'.length).substr(0, 12);
      };
    }
  };
  return directiveDefinitionObject;
});