import { Input, Output, Component, EventEmitter, OnChanges, SimpleChanges } from 'ng-metadata/core';


/**
 * A component that lets the user set up a build trigger for a custom Git repository.
 */
@Component({
  selector: 'manage-trigger-custom-git',
  templateUrl: '/static/js/directives/ui/manage-trigger-custom-git/manage-trigger-custom-git.component.html'
})
export class ManageTriggerCustomGitComponent implements OnChanges {

  // FIXME: Use one-way data binding
  @Input('=') public trigger: {config: any};
  @Output() public activateTrigger: EventEmitter<{config: any, pull_robot?: any}> = new EventEmitter();
  private config: any = {};
  private currentState: any | null;

  public ngOnChanges(changes: SimpleChanges): void {
    if (changes['trigger'] !== undefined) {
      this.config = Object.assign({}, changes['trigger'].currentValue.config);
    }
  }
}
